Index: /trunk/src/sh_socket.c
===================================================================
--- /trunk/src/sh_socket.c	(revision 584)
+++ /trunk/src/sh_socket.c	(revision 1)
@@ -1109,65 +905,16 @@
 
   new = SH_ALLOC(sizeof(struct socket_cmd));
-  sl_strlcpy (new->cmd,  in->cmd,  sizeof(new->cmd));
-  sl_strlcpy (new->clt,  in->clt,  sizeof(new->clt));
-  (void) sh_unix_time(0, new->cti, sizeof(new->cti));
-  new->next  = NULL;
-
-  if (last)
-    {
-      while (last->next) { last = last->next; }
-      last->next = new;
-    }
-  else
-    {
-      cmdlist = new;
-    }
+  strcpy (new->cmd, in->cmd);
+  strcpy (new->clt, in->clt);
+  strcpy (new->cti, sh_unix_time(0));
+  new->next = runlist;
+  runlist   = new;
+
   return;
 }
 
-static void sh_socket_add2run (struct socket_cmd * in)
-{
-  struct socket_cmd  * new  = runlist;
-  struct socket_cmd  * last = runlist;
-
-  while (new)
-    {
-      /* Only skip identical commands. First 5 will
-       * make all 'DELTA' identical.
-       */
-      if (0 == sl_strcmp(new->clt,  in->clt) &&
-	  0 == sl_strncmp(new->cmd,  in->cmd, 5))
-	{
-	  sl_strlcpy (new->cmd,  in->cmd,  sizeof(new->cmd));
-	  (void) sh_unix_time(0, new->cti, sizeof(new->cti));
-	  return;
-	}
-      new = new->next;
-    }
-
-  new = SH_ALLOC(sizeof(struct socket_cmd));
-  sl_strlcpy (new->cmd,  in->cmd,  sizeof(new->cmd));
-  sl_strlcpy (new->clt,  in->clt,  sizeof(new->clt));
-#ifdef SH_DEBUG_SOCKET
-  fprintf(stderr, "add2run: time set for %s\n", new->clt);
-#endif
-  (void) sh_unix_time(0, new->cti, sizeof(new->cti));
-  new->next  = NULL;
-
-  if (last)
-    {
-      while (last->next) { last = last->next; }
-      last->next = new;
-    }
-  else
-    {
-      runlist = new;
-    }
-  return;
-}
-
-
-
-static void sh_socket_rm2list (const char * client_name, int remove_all)
+
+
+static void sh_socket_rm2list (const char * client_name)
 {
   struct socket_cmd * old = cmdlist;
@@ -1180,5 +927,4 @@
 	  if ((new == cmdlist) && (new->next == NULL))
 	    {
-	      /* There is only one entry */
 	      cmdlist = NULL;
 	      SH_FREE(new);
@@ -1187,12 +933,7 @@
 	  else if (new == cmdlist)
 	    {
-	      /* first entry: new = old = cmdlist */
 	      cmdlist = new->next;
 	      SH_FREE(new);
-	      if (remove_all == S_FALSE)
-		return;
-	      old = cmdlist;
-	      new = cmdlist;
-	      continue;
+	      return;
 	    }
 	  else
@@ -1200,7 +941,5 @@
 	      old->next = new->next;
 	      SH_FREE(new);
-	      if (remove_all == S_FALSE)
-		return;
-	      new = old;
+	      return;
 	    }
 	}
@@ -1221,14 +960,21 @@
 
   if (pf_unix_fd  < 0)
-    return 0;
-
-  sl_strlcpy(cancel_cmd, _("CANCEL"), sizeof(cancel_cmd)); 
+    {
+      return 0;
+    }
+
+  sl_strlcpy(cancel_cmd, _("CANCEL"), SH_MAXMSGLEN); 
 
   while (sh_socket_read (&cmd) > 0)
     {
       if (0 == sl_strcmp(cmd.cmd, cancel_cmd))
-	sh_socket_rm2list  (cmd.clt, S_TRUE);
+	{
+	  sh_socket_rm2list  (cmd.clt);
+	}
       else
-	sh_socket_add2list (&cmd);
+	{
+	  sh_socket_rm2list  (cmd.clt);
+	  sh_socket_add2list (&cmd);
+	}
     }
   return 0;
@@ -1240,4 +986,5 @@
 char * sh_socket_check(const char * client_name)
 {
+  struct socket_cmd * old = cmdlist;
   struct socket_cmd * new = cmdlist;
   static char         out[SH_MAXMSGLEN];
@@ -1247,149 +994,17 @@
       if (0 == sl_strcmp(new->clt, client_name))
 	{
-	  sl_strlcpy(out,  new->cmd,  sizeof(out));
+	  sl_strlcpy(out, new->cmd, SH_MAXMSGLEN);
 	  sh_socket_add2run (new);
-	  sh_socket_rm2list (client_name, S_FALSE);
+	  sh_socket_rm2list  (client_name);
 	  return out;
 	}
+      old = new;
       new = new->next;
     }
   return NULL;
 }
+
 /* #if defined (SH_WITH_SERVER)
  */
 #endif
 
-
-#ifdef SH_CUTEST
-#include "CuTest.h"
-
-void Test_cmdlist (CuTest *tc) {
-
-#if defined (SH_WITH_SERVER)
-  struct socket_cmd cmd;
-  char * p;
-
-  sl_strlcpy(cmd.clt, "one", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "RELOAD", sizeof(cmd.cmd));
-
-  sh_socket_add2list (&cmd);
-  p = sh_socket_check("one");
-  CuAssertPtrNotNull(tc, p);
-  CuAssertStrEquals(tc, "RELOAD", p);
-
-  p = sh_socket_check("one");
-  CuAssertPtrEquals(tc, NULL, p);
-
-  sh_socket_add2list (&cmd);
-  sl_strlcpy(cmd.cmd, "STOP",   sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-
-  sl_strlcpy(cmd.clt, "two", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "STOP", sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-  sl_strlcpy(cmd.clt, "three", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "STOP", sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-
-  sl_strlcpy(cmd.clt, "one", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "DELTA",   sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-
-  p = sh_socket_check("one");
-  CuAssertPtrNotNull(tc, p);
-  CuAssertStrEquals(tc, "RELOAD", p);
-
-  sl_strlcpy(cmd.clt, "two", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "RELOAD", sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-  sl_strlcpy(cmd.clt, "three", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "RELOAD", sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-
-  p = sh_socket_check("one");
-  CuAssertPtrNotNull(tc, p);
-  CuAssertStrEquals(tc, "STOP", p);
-  p = sh_socket_check("one");
-  CuAssertPtrNotNull(tc, p);
-  CuAssertStrEquals(tc, "DELTA", p);
-  p = sh_socket_check("one");
-  CuAssertPtrEquals(tc, NULL, p);
-
-  /* Test removal in correct order */
-  sl_strlcpy(cmd.clt, "one", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "RELOAD", sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-  sl_strlcpy(cmd.cmd, "STOP",   sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-  sl_strlcpy(cmd.cmd, "DELTA",  sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-  sl_strlcpy(cmd.cmd, "FOOBAR", sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-  
-  sh_socket_rm2list ("one", S_FALSE);
-
-  p = sh_socket_check("one");
-  CuAssertPtrNotNull(tc, p);
-  CuAssertStrEquals(tc, "STOP", p);
-
-  sh_socket_rm2list ("one", S_FALSE);
-  
-  p = sh_socket_check("one");
-  CuAssertPtrNotNull(tc, p);
-  CuAssertStrEquals(tc, "FOOBAR", p);
-
-  p = sh_socket_check("one");
-  CuAssertPtrEquals(tc, NULL, p);
-
-  sl_strlcpy(cmd.clt, "one", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "RELOAD", sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-  sl_strlcpy(cmd.cmd, "STOP",   sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-
-  sl_strlcpy(cmd.clt, "two", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "RELOAD", sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-  sl_strlcpy(cmd.clt, "three", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "RELOAD", sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-
-  sl_strlcpy(cmd.clt, "one", sizeof(cmd.clt));
-  sl_strlcpy(cmd.cmd, "DELTA",  sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-  sl_strlcpy(cmd.cmd, "FOOBAR", sizeof(cmd.cmd));
-  sh_socket_add2list (&cmd);
-
-  sh_socket_rm2list ("one", S_TRUE);
-  p = sh_socket_check("one");
-  CuAssertPtrEquals(tc, NULL, p);
-
-  p = sh_socket_check("two");
-  CuAssertPtrNotNull(tc, p);
-  CuAssertStrEquals(tc, "STOP", p);
-  p = sh_socket_check("two");
-  CuAssertPtrNotNull(tc, p);
-  CuAssertStrEquals(tc, "RELOAD", p);
-  p = sh_socket_check("two");
-  CuAssertPtrEquals(tc, NULL, p);
-
-  p = sh_socket_check("three");
-  CuAssertPtrNotNull(tc, p);
-  CuAssertStrEquals(tc, "STOP", p);
-  p = sh_socket_check("three");
-  CuAssertPtrNotNull(tc, p);
-  CuAssertStrEquals(tc, "RELOAD", p);
-  p = sh_socket_check("three");
-  CuAssertPtrEquals(tc, NULL, p);
-
-  p = sh_socket_check("four");
-  CuAssertPtrEquals(tc, NULL, p);
-#else
-  (void) tc;
-#endif
-}
-
-#endif  /* #ifdef SH_CUTEST */
-
-
-
Index: /trunk/src/sh_srp.c
===================================================================
--- /trunk/src/sh_srp.c	(revision 584)
+++ /trunk/src/sh_srp.c	(revision 1)
@@ -29,17 +29,4 @@
 #ifdef USE_SRP_PROTOCOL
 
-/* dont modify this, unless you know what you do
- */
-#define SRP_GENERATOR_1024      "2"
-#define SRP_MODULUS_1024_1        \
-_("f488fd584e49dbcd20b49de49107366b336c380d451d0f7c88b31c7c5b2d8ef6") 
-#define SRP_MODULUS_1024_2        \
-_("f3c923c043f0a55b188d8ebb558cb85d38d334fd7c175743a31d186cde33212c") 
-#define SRP_MODULUS_1024_3        \
-_("b52aff3ce1b1294018118d7c84a70a72d686c40319c807297aca950cd9969fab")
-#define SRP_MODULUS_1024_4        \
-_("d00a509b0246d3083d66a45d419f9c7cbd894b221926baaba25ec355e92f78c7")
-
-
 #if (defined (SH_WITH_CLIENT) || defined (SH_WITH_SERVER))
 
@@ -61,5 +48,5 @@
 #define bignum MP_INT
 
-static
+inline
 int big_create (bignum * a)
 {
@@ -68,5 +55,5 @@
 }
 
-static
+inline
 int big_zerop (bignum * a)
 {
@@ -82,5 +69,5 @@
 }
 
-static
+inline
 int big_trunc (bignum * a, bignum * b, bignum * q, bignum *r)
 {
@@ -89,5 +76,5 @@
 }
 
-static
+inline
 int big_exptmod (bignum * a, bignum * b, bignum * c, bignum *d)
 {
@@ -99,5 +86,5 @@
 int    siz_str_internal = 0;
 
-static
+inline
 char * big_string (bignum * a, int base)
 {
@@ -109,5 +96,5 @@
   if (get_str_internal == NULL)
     {
-      get_str_internal = calloc(1,512);   /* only once */
+      get_str_internal = malloc(512);   /* only once */
       if (get_str_internal)
 	{
@@ -127,17 +114,5 @@
       size = strlen(str) + 1;
       if (size > siz_str_internal)
-	{
-	  char * ptr = realloc (get_str_internal, size);
-	  if (ptr)
-	    get_str_internal = ptr;
-	  else
-	    {
-	      /* "If realloc() fails, the original block is left untouched;
-	       * it is not freed or moved." */
-	      /* cppcheck-suppress doubleFree */
-	      free(get_str_internal);
-	      get_str_internal = NULL;
-	    }
-	}
+	get_str_internal = realloc (get_str_internal, size);
       if (get_str_internal == NULL)
 	{
@@ -146,5 +121,5 @@
 	}
       siz_str_internal = size;
-      sl_strlcpy (get_str_internal, str, siz_str_internal);
+      strcpy (get_str_internal, str);                   /* known to fit  */
       for (i = 0; i < (size-1); ++i)
 	if (get_str_internal[i] >= 'a' && get_str_internal[i] <= 'f' )
@@ -155,5 +130,5 @@
 }
 
-static 
+inline 
 int big_add(bignum * a, bignum * b, bignum * c)
 {
@@ -162,5 +137,5 @@
 }
 
-static 
+inline 
 int big_sub(bignum * a, bignum * b, bignum * c)
 {
@@ -169,5 +144,5 @@
 }
 
-static 
+inline 
 int big_mul(bignum * a, bignum * b, bignum * c)
 {
@@ -176,5 +151,5 @@
 }
 
-static 
+inline 
 int big_greaterp(bignum * a, bignum * b)
 {
@@ -182,5 +157,5 @@
 }
 
-static 
+inline 
 int big_set_big(bignum * a, bignum * b)
 {
@@ -190,5 +165,5 @@
 
 
-static 
+inline 
 int big_set_string(const char * str, int base, bignum * a)
 {
@@ -222,8 +197,7 @@
 
   char           *combi;
-  size_t          len, l2;
+  size_t          len;
   register int i;
   unsigned char * dez = NULL;
-  char hashbuf[KEYBUF_SIZE];
 
   SL_ENTER(_("sh_srp_x"));
@@ -244,13 +218,8 @@
 
   (void) sl_strlcpy (skey->vernam,
-		     sh_tiger_hash(skey->vernam, TIGER_DATA, PW_LEN, 
-				   hashbuf, sizeof(hashbuf)), 
-		     KEY_LEN);
+		     sh_tiger_hash(skey->vernam, TIGER_DATA, PW_LEN), KEY_LEN);
   skey->vernam[KEY_LEN] = '\0';
 
-  len = sl_strlen(salt) + 1;
-  l2  = sl_strlen(skey->vernam);
-  if (sl_ok_adds(len, l2))
-    len += l2;
+  len = sl_strlen(salt) + sl_strlen(skey->vernam) + 1;
 
   /* H(s,P)
@@ -261,6 +230,5 @@
   (void) sl_strlcpy (sh_srp.x, 
 		     sh_tiger_hash(combi, TIGER_DATA, 
-				   (unsigned long) sl_strlen(combi),
-				   hashbuf, sizeof(hashbuf)),
+				   (unsigned long) sl_strlen(combi)),
 		     KEY_LEN+1);
   SH_FREE (combi);
@@ -269,8 +237,9 @@
 }
 
-char * sh_srp_M (char * x1, char * x2, char * x3, char * hash, size_t size)
+char * sh_srp_M (char * x1, char * x2, char * x3)
 {
   char           *combi;
-  size_t          len, l2, l3;
+  size_t          len;
+  static char     hash[KEY_LEN+1];
   
   SL_ENTER(_("sh_srp_M"));
@@ -279,12 +248,5 @@
 	     _("x1 != NULL && x2 != NULL && x3 !=NULL"), NULL);
 
-  len = sl_strlen(x1) + 1;
-  l2  = sl_strlen(x2); 
-  l3  = sl_strlen(x3);
-
-  if (sl_ok_adds(len, l2))
-    len += l2;
-  if (sl_ok_adds(len, l3))
-    len += l3;
+  len = sl_strlen(x1) + sl_strlen(x2) + sl_strlen(x3) + 1;
   
   /* H(x1,x2,x3)
@@ -294,6 +256,7 @@
   (void) sl_strlcat (combi, x2, len);
   (void) sl_strlcat (combi, x3, len);
-  (void) sh_tiger_hash(combi, TIGER_DATA, (unsigned long) (len-1),
-		       hash, size);
+  (void) sl_strlcpy (hash, 
+		     sh_tiger_hash(combi, TIGER_DATA, (unsigned long) (len-1)),
+		     KEY_LEN+1);
   SH_FREE (combi);
   
@@ -362,15 +325,14 @@
   int    res;
   char   hash[KEY_LEN+1];
-  char hashbuf[KEYBUF_SIZE];
 
   SL_ENTER(_("sh_srp_make_a"));
 
   for (i = 0; i < 6; ++i)
-    randl[i] = (UINT32) taus_get ();
-
+    randl[i] = (UINT32) taus_get (&(skey->rng0[0]), 
+				  &(skey->rng1[0]),
+				  &(skey->rng2[0]));
   (void) sl_strlcpy (hash, 
 		     sh_tiger_hash((char *)&randl[0], TIGER_DATA, 
-				   (unsigned long) 6*sizeof(UINT32),
-				   hashbuf, sizeof(hashbuf)), 
+				   (unsigned long) 6*sizeof(UINT32)), 
 		     KEY_LEN+1);
 
@@ -413,5 +375,4 @@
   if (res != BIG_OK)             val = (-1);
   else if (0 != big_zerop(&AB) ) val = (-1); /* 0 != (sign == 0) */
-  else if (0 != big_zerop(&r) )  val = (-1); /* 0 != (sign == 0) */
   else                           val =    0;
 
@@ -423,5 +384,5 @@
 }
 
-#if defined(SH_WITH_CLIENT) || defined(SH_WITH_SERVER)
+#ifdef SH_WITH_CLIENT
   
 
@@ -431,4 +392,5 @@
   char    *str;
   char    *combi;
+  size_t   len;
   bigerr_t res;
 
@@ -446,5 +408,9 @@
   
   if (str != NULL)
-    combi = sh_util_strdup(str);
+    {
+      len = sl_strlen(str) + 1;
+      combi = SH_ALLOC(len);
+      (void) sl_strlcpy (combi, str, len);
+    }
   else
     combi = NULL;
@@ -464,4 +430,5 @@
   char    *str;
   char    *combi;
+  long     len;
   bigerr_t res;
 
@@ -502,5 +469,10 @@
   
   if (str != NULL)
-    combi = sh_util_strdup(str);
+    {
+      len = sl_strlen(str) + 1;
+      combi = SH_ALLOC(len);
+      sl_strlcpy (combi, str, len);
+      /* fprintf(stderr, "OK2a %ld %s\n", len, combi); */
+    }
   else
     combi = NULL;
@@ -517,5 +489,5 @@
   
   
-#if defined(SH_WITH_CLIENT) || defined(SH_WITH_SERVER)
+#ifdef SH_WITH_CLIENT
   
 char * sh_srp_S_c (char * u_str, char * B_str)
@@ -524,4 +496,5 @@
   char    *str;
   char    *combi;
+  size_t   len;
   bigerr_t res;
 
@@ -598,5 +571,9 @@
 
   if (str != NULL)
-    combi = sh_util_strdup(str);
+    {
+      len = sl_strlen(str) + 1;
+      combi = SH_ALLOC(len);
+      (void) sl_strlcpy (combi, str, len);
+    }
   else
     combi = NULL;
@@ -624,4 +601,5 @@
   char    *str;
   char    *combi;
+  size_t   len;
   bigerr_t res;
 
@@ -673,5 +651,9 @@
   
   if (str != NULL)
-    combi = sh_util_strdup(str);
+    {
+      len = sl_strlen(str) + 1;
+      combi = SH_ALLOC(len);
+      (void) sl_strlcpy (combi, str, len);
+    }
   else
     combi = NULL;
@@ -697,4 +679,5 @@
   char    *combi;
   char    *str;
+  size_t   len;
   bigerr_t res;
   
@@ -717,5 +700,9 @@
   
   if (str != NULL)
-    combi = sh_util_strdup(str);
+    {
+      len = sl_strlen(str) + 1;
+      combi = SH_ALLOC(len);
+      (void) sl_strlcpy (combi, str, len);
+    }
   else
     combi = NULL;
@@ -737,95 +724,4 @@
 
 
-#ifdef SH_CUTEST
-#include "CuTest.h"
-
-void Test_srp (CuTest *tc)
-{
-#if defined(USE_SRP_PROTOCOL) && (defined (SH_WITH_CLIENT) || defined (SH_WITH_SERVER))
-
-  int result;
-  char     modulus[80*4];
-  bignum   a, b, c;
-  bigerr_t res;
-  char    *str = NULL;
-
-  res = sh_srp_init();
-  CuAssertTrue(tc, res == 0);
-
-  (void) sl_strlcpy(modulus, SRP_MODULUS_1024_1, sizeof(modulus));
-  (void) sl_strlcat(modulus, SRP_MODULUS_1024_2, sizeof(modulus));
-  (void) sl_strlcat(modulus, SRP_MODULUS_1024_3, sizeof(modulus));
-  (void) sl_strlcat(modulus, SRP_MODULUS_1024_4, sizeof(modulus));
-
-  res = big_create(&a);
-  CuAssertTrue(tc, res == BIG_OK);
-
-  /* Check plain zero 
-   */
-  result = sh_srp_check_zero ("0");
-  CuAssertTrue(tc, result != 0);
-  
-  res = big_set_string ("0",  16, &a);
-  CuAssertTrue(tc, res == BIG_OK);
-
-  result = sh_srp_check_zero (big_string(&a, 16));
-  CuAssertTrue(tc, result != 0);
-
-  /* Check modulus (equals 0 % M) 
-   */
-  result = sh_srp_check_zero (modulus);
-  CuAssertTrue(tc, result != 0);
-
-  res = big_set_string (modulus,  16, &a);
-  CuAssertTrue(tc, res == BIG_OK);
-
-  result = sh_srp_check_zero (big_string(&a, 16));
-  CuAssertTrue(tc, result != 0);
-
-  /* Check non-zero 
-   */
-  modulus[0] = 'a';
-
-  result = sh_srp_check_zero (modulus);
-  CuAssertTrue(tc, result == 0);
-
-  res = big_set_string (modulus,  16, &a);
-  CuAssertTrue(tc, res == BIG_OK);
-
-  result = sh_srp_check_zero (big_string(&a, 16));
-  CuAssertTrue(tc, result == 0);
-
-  modulus[0] = 'f';
-
-  /* Check multiple of modulus 
-   */
-  res = big_set_string (modulus,  16, &a);
-  CuAssertTrue(tc, res == BIG_OK);
-
-  res = big_create(&b);
-  CuAssertTrue(tc, res == BIG_OK);
-
-  res = big_create(&c);
-  CuAssertTrue(tc, res == BIG_OK);
-
-  res = big_set_string ("deadbeef", 16, &b);
-  CuAssertTrue(tc, res == BIG_OK);
-
-  res = big_mul (&a, &b, &c);
-  CuAssertTrue(tc, res == BIG_OK);
-
-  str = strdup(big_string (&c, 16));
-  CuAssertPtrNotNull(tc, str);
-
-  result = sh_srp_check_zero (str);
-  CuAssertTrue(tc, result != 0);
-
-#else
-  (void) tc; /* fix compiler warning */
-#endif
-  return;
-}
-#endif
-
-
-
+
+
